/* io_auxiliary.h
 * 
 * Copyright (C) 2015 Tristan Dagobert, Ecole Normale Superieure de Cachan.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @mainpage
 *
 * README.txt:
 * @verbinclude README.txt
 */

/**
 * @file io_auxiliary.h
 * @brief
 *
 * 
 *
 * @todo 
 *
 * @author Tristan Dagobert <tristan.dagobert@cmla.ens-cachan.fr>
 */

#if !(defined AUXILIARY_H)
#define AUXILIARY_H

files_list *create_files_list (char *list_file_name);
void free_files_list(files_list *flist_head);

window_API *load_one_image (window_API * win_API, unsigned int window_width,
			    char *png_file_name);
void print_matrix (char *desc, int nrows, int ncols, float *mat, int lda);
void free_parameters (parameters * param);
void free_window (window * win);
void free_window_API (window_API * win_API);
void dynamic_requantization (float *image, int width, int height,
			int channel_number);
void dynamic_rescaling (float *image, int width, int height,
			int channel_number, float scale_factor);
void dynamic_saturation(float *image, int width, int height,
			int channel_number, float minimum, float maximum);
void write_image (char *generic_name, float *im, int ncols, int nrows, 
		  int dynamic_transformation);
#endif
