/* pca_method.h
 * 
 * Copyright (C) 2015 Tristan Dagobert, Ecole Normale Superieure de Cachan.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @mainpage
 *
 * README.txt:
 * @verbinclude README.txt
 */

/**
 * @file pca_method.h
 * @brief
 *
 * 
 *
 * @todo 
 *
 * @author Tristan Dagobert <tristan.dagobert@cmla.ens-cachan.fr>
 */

#if !(defined PCA_METHOD_H)
#define PCA_METHOD_H
void zeros(float ** output, int npix);

float * compute_laplacian_mu(float * mu, float * laplacian, window_API * win_API);
float * create_laplacian_filter(void);

float *compute_mean_image (window_API * win_API);
float *create_matrix_A (window_API * win_API, float *mean_im);
float *compute_eigens (float *A, int A_nrows, int A_ncols);
void sort_eigens (float *eigen_vals, float *eigen_vecs, int neigens);
float *compute_basis (float *A, int A_nrows, int A_ncols, float *eigen_vecs);
float *compute_image_from_v1 (float *A, int last_eigenvec, int A_nrows,
			      int A_ncols, float *eigen_vecs, float *mean_im);
float *compute_image_from_partial_basis (float *im, int first_vec, int last_vec,
					 int nrows, float *basis_vecs,
					 float *mean_im);

void print_statistics (float *im, int npixs);
void print_eigenvalues (float *eigenvals, int nvals);

float var(float * input, int npix);
void image_image_op(float ** output, float * im1, char *operator, float * im2, int npix);
void image_scalar_op(float ** output, float * im1, char *operator, float scalar, int npix);
#endif
